package cn.com.infosec.asn1;

import java.util.Enumeration;

public class BERTaggedObject extends DERTaggedObject {
   public BERTaggedObject(int tagNo, DEREncodable obj) {
      super(tagNo, obj);
   }

   public BERTaggedObject(boolean explicit, int tagNo, DEREncodable obj) {
      super(explicit, tagNo, obj);
   }

   public BERTaggedObject(int tagNo) {
      BERTaggedObject var10000 = this;
      BERSequence var2;
      var2 = new BERSequence.<init>();
      var10000.<init>(false, tagNo, var2);
   }

   void encode(DEROutputStream out) {
      if (!(out instanceof ASN1OutputStream) && !(out instanceof BEROutputStream)) {
         super.encode(out);
      } else {
         out.write(super.tagNo | 160);
         out.write(128);
         if (!super.empty) {
            if (!super.explicit) {
               DEREncodable var2;
               if ((var2 = super.obj) instanceof ASN1OctetString) {
                  Enumeration var4;
                  if (var2 instanceof BERConstructedOctetString) {
                     var4 = ((BERConstructedOctetString)var2).getObjects();
                  } else {
                     ASN1OctetString var5 = (ASN1OctetString)var2;
                     var4 = (new BERConstructedOctetString(var5.getOctets())).getObjects();
                  }

                  while(var4.hasMoreElements()) {
                     out.writeObject(var4.nextElement());
                  }
               } else if (var2 instanceof ASN1Sequence) {
                  Enumeration var3 = ((ASN1Sequence)var2).getObjects();

                  while(var3.hasMoreElements()) {
                     out.writeObject(var3.nextElement());
                  }
               } else {
                  if (!(var2 instanceof ASN1Set)) {
                     throw new RuntimeException("not implemented: " + super.obj.getClass().getName());
                  }

                  Enumeration var6 = ((ASN1Set)var2).getObjects();

                  while(var6.hasMoreElements()) {
                     out.writeObject(var6.nextElement());
                  }
               }
            } else {
               out.writeObject(super.obj);
            }
         }

         out.write(0);
         out.write(0);
      }

   }
}
